﻿using System;
using System.Data.OleDb;
using System.Data;
using System.IO;
using System.Drawing;

using Spire.Xls;

namespace ExportDataTableIntoXLS
{
    class Program
    {
        static void Main(string[] args)
        {
            string connString = "Provider=Microsoft.ACE.OLEDB.12.0;Data Source=" + Directory.GetCurrentDirectory()
                 + @"..\..\..\demo.mdb;Persist Security Info=False;";
            Workbook workbook = new Workbook();
            workbook.CreateEmptySheets(new String[]{"Parts-Items"});
            Worksheet worksheet = workbook.Worksheets[0];
            using (OleDbConnection con = new OleDbConnection(connString))
            {
                con.Open();
                DataTable parts = new DataTable();
                string sql = "select * from parts";
                OleDbDataAdapter oda = new OleDbDataAdapter(sql, con);
                //Gets a collection that provides the master mapping between a source table and a DataTable.
                oda.TableMappings.Add("Table", "parts");
                oda.Fill(parts);

                sql = "select * from items";
                DataTable items = new DataTable();
                oda = new OleDbDataAdapter(sql, con);
                oda.TableMappings.Add("Table", "items");
                oda.Fill(items);

                DataView subItems = new DataView(items);

                worksheet.InsertDataTable(parts, true, 1, 1);
                worksheet.Range["A1:G1"].Style.Color = Color.Orange;
                worksheet.Range["A2:G1064"].Style.Color = Color.LightYellow;

                //index of PartNo
                int partNoColumnIndex = 0;
                foreach(DataColumn column in parts.Columns)
                {
                    if (column.ColumnName == "PartNo")
                    {
                        partNoColumnIndex = column.Ordinal;
                        break;
                    }
                }

                for (int r = 0, rowIndex = 3, count = parts.Rows.Count; r < count; r++, rowIndex++)
                {
                    object partNo = parts.Rows[r][partNoColumnIndex];
                    String filter = String.Format("PartNo = {0}", partNo);
                    subItems.RowFilter = filter;
                    subItems.RowStateFilter = DataViewRowState.CurrentRows;
                    int subItemCount = subItems.Count;

                    if (subItemCount > 0)
                    {
                        worksheet.InsertRow(rowIndex, subItemCount + 1);
                        worksheet.InsertDataView(subItems, true, rowIndex, 1);
                        worksheet.Rows[rowIndex - 1].Style.Color = Color.Green;
                        worksheet.GroupByRows(rowIndex, rowIndex + subItemCount, true);
                        rowIndex = rowIndex + subItemCount + 1;
                    }
                }
            }
            workbook.SaveToFile(@"..\..\Test.xlsx", ExcelVersion.Version2010);
            System.Diagnostics.Process.Start(@"..\..\Test.xlsx");
        }
    }
}
